#!/bin/sh

path=$(pwd)

fileconf="/config/bmminer.conf"

grep -r "bitmain-freq" $fileconf | cut -d "\"" -f 4 > /tmp/freqtemp
grep -r "bitmain-voltage" $fileconf | cut -d "\"" -f 4 > /tmp/voltagetemp

freq=`sed -n "1p" /tmp/freqtemp`
freq1=`sed -n "2p" /tmp/freqtemp`
freq2=`sed -n "3p" /tmp/freqtemp`
freq3=`sed -n "4p" /tmp/freqtemp`
freq4=`sed -n "5p" /tmp/freqtemp`
freq5=`sed -n "6p" /tmp/freqtemp`
freq6=`sed -n "7p" /tmp/freqtemp`

voltage=`sed -n "1p" /tmp/voltagetemp`
voltage1=`sed -n "2p" /tmp/voltagetemp`
voltage2=`sed -n "3p" /tmp/voltagetemp`
voltage3=`sed -n "4p" /tmp/voltagetemp`
voltage4=`sed -n "5p" /tmp/voltagetemp`
voltage5=`sed -n "6p" /tmp/voltagetemp`
voltage6=`sed -n "7p" /tmp/voltagetemp`

if [ ${freq} ] && [ ${freq} -ne 475 ]; then
	sed -i 's,^\(\"bitmain-freq\" : \).*,\1'\"475\"\\,',' $fileconf
fi 

if [ ${freq1} ] && [ ${freq1} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq1\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq2} ] && [ ${freq2} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq2\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq3} ] && [ ${freq3} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq3\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq4} ] && [ ${freq4} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq4\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq5} ] && [ ${freq5} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq5\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq6} ] && [ ${freq6} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq6\" : \).*,\1'\"0\"\\,',' $fileconf
fi 


if [ ${voltage} ] && [ ${voltage} -ne 820 ]; then
	sed -i 's,^\(\"bitmain-voltage\" : \).*,\1'\"820\"\\,',' $fileconf
fi 

if [ ${voltage1} ] && [ ${voltage1} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage1\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage2} ] && [ ${voltage2} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage2\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage3} ] && [ ${voltage3} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage3\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage4} ] && [ ${voltage4} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage4\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage5} ] && [ ${voltage5} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage5\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage6} ] && [ ${voltage6} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage6\" : \).*,\1'\"0\"\\,',' $fileconf
fi 


cp_config="all"
if [ ! -d /mnt/upgrade ];
then
	mkdir /mnt/upgrade
fi

if [ -e /usr/bin/ctrl_bd ]; then
ret=`cat /usr/bin/ctrl_bd | grep "XILINX" | wc -l`
else
ret=0
fi

if [ $ret -eq 1 ];then
    cd ./xilinx
    
    if [ -e /dev/ubi_ctrl ];then

        if [ ! -d /mnt/config ];then
            mkdir /mnt/config
        fi
        ubiattach /dev/ubi_ctrl -m 2
        mount -t ubifs ubi1:rootfs /mnt/config
        if [ ! -d /mnt/config/home/usr_config ];then
            mkdir /mnt/config/home/usr_config
        fi

        if [ `ls /mnt/config/home/usr_config | wc -l` -gt 1 ];then
            cp_config="all" #cp -r /config/* /mnt/config/home/usr_config/
        else
            cp_config="mac" #cp -r /config/mac /mnt/config/home/usr_config/
        fi

        umount /mnt/config
        ubidetach -d 1 /dev/ubi_ctrl
    fi
    
    if [ -e BOOT.bin ]; then
            flash_erase /dev/mtd0 0x0 0x80 >/dev/null 2>&1
            nandwrite -p -s 0x0 /dev/mtd0 ./BOOT.bin >/dev/null 2>&1
            rm -rf BOOT.bin
    fi

    if [ -e devicetree.dtb ]; then
            flash_erase /dev/mtd0 0x1020000 0x1 >/dev/null 2>&1
            nandwrite -p -s 0x1020000 /dev/mtd0 ./devicetree.dtb >/dev/null 2>&1
            rm devicetree.dtb
    fi

    if [ -e uImage ]; then 
            flash_erase /dev/mtd0 0x1100000 0x40 >/dev/null 2>&1
            nandwrite -p -s 0x1100000 /dev/mtd0 ./uImage >/dev/null 2>&1
            rm uImage
    fi

    if [ -e rootfs.jffs2 ]; then
            if [ -f /dev/mtd3 ];then
                flash_erase /dev/mtd2 0x0 0x1E0 >/dev/null 2>&1
            else
                flash_erase /dev/mtd2 0x0 0x280 >/dev/null 2>&1
            fi
            nandwrite -p -s 0x0 /dev/mtd2 ./rootfs.jffs2 >/dev/null 2>&1
            rm rootfs.jffs2
    fi

    if [ -e /dev/ubi_ctrl ];then
        if [ ! -d /mnt/config ];then
            mkdir /mnt/config
        fi
        ubiattach /dev/ubi_ctrl -m 2
        mount -t ubifs ubi1:rootfs /mnt/config
        if [ ! -d /mnt/config/home/usr_config ];then
            mkdir /mnt/config/home/usr_config
        fi
        if [ $cp_config == "all" ];then
            cp -r /config/* /mnt/config/home/usr_config/
        else
            cp -r /config/mac /mnt/config/home/usr_config/
        fi
        sync
        umount /mnt/config
        ubidetach -d 1 /dev/ubi_ctrl
    fi

    if [ -e /dev/ubi_ctrl ];then
        ubiattach /dev/ubi_ctrl -m 2
        mount -t ubifs ubi1:rootfs /mnt/upgrade
    
        cd /mnt/upgrade/upgrade
        rm -rf /mnt/upgrade/upgrade/*
        cd $path

        if [ -e ./xilinx/angstrom_rootfs.jffs2 ];then
            md5=`md5sum ./xilinx/angstrom_rootfs.jffs2 | awk {'print $1'}`
            md5_r=`cat ubi_info`
            if [ $md5 == $md5_r ];then
                cp -rf ./xilinx/angstrom_rootfs.jffs2 /mnt/upgrade/upgrade
                if [ -f /dev/mtd3 ];then
                    flash_erase /dev/mtd3 0 0xa0 >/dev/null 2>&1
                fi
            fi
        fi
        flash_erase /dev/mtd0 0x1040000 0x1 >/dev/null 2>&1
        nandwrite -p -s 0x1040000 /dev/mtd0 ./xilinx/upgrade-marker.bin >/dev/null 2>&1

        sync

        umount /mnt/upgrade
        ubidetach -d 1 /dev/ubi_ctrl
    fi    
else
    echo "this is not for c5"
fi
 
rm -rf *.tar.gz


#/sbin/reboot -f &
